diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/make/modules/java.desktop/lib/Awt2dLibraries.gmk jdk18u-jdk-18.0.2.1-ga/make/modules/java.desktop/lib/Awt2dLibraries.gmk
--- jdk18u-jdk-18.0.2.1-ga.orig/make/modules/java.desktop/lib/Awt2dLibraries.gmk	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/make/modules/java.desktop/lib/Awt2dLibraries.gmk	2024-08-17 18:29:44.458356145 +0200
@@ -76,7 +76,7 @@
       #
 endif
 
-ifeq ($(call isTargetOs, linux macosx aix), true)
+ifeq ($(call isTargetOs, solaris linux macosx aix), true)
   LIBAWT_EXFILES += awt_Font.c CUPSfuncs.c fontpath.c X11Color.c
 endif
 
@@ -156,6 +156,7 @@
         -delayload:comctl32.dll -delayload:shlwapi.dll, \
     LIBS_unix := -ljvm -ljava $(LIBM), \
     LIBS_linux :=  $(LIBDL), \
+    LIBS_solaris := $(LIBDL), \
     LIBS_aix := $(LIBDL),\
     LIBS_macosx := -lmlib_image \
         -framework Cocoa \
@@ -387,6 +388,7 @@
       LDFLAGS_unix := -L$(INSTALL_LIBRARIES_HERE), \
       LIBS_unix := -lawt -ljvm -ljava, \
       LIBS_linux := $(LIBM) $(LIBDL), \
+      LIBS_solaris := $(LIBM) $(LIBDL) $(LIBCXX), \
   ))
 
   $(BUILD_LIBAWT_HEADLESS): $(BUILD_LIBAWT)
@@ -444,7 +446,7 @@
                         -DHAVE_SYSCONF -DHAVE_SYS_MMAN_H -DHAVE_UNISTD_H \
                         -DHB_NO_PRAGMA_GCC_DIAGNOSTIC
    endif
-   ifeq ($(call isTargetOs, linux macosx), true)
+   ifeq ($(call isTargetOs, solaris linux macosx), true)
      HARFBUZZ_CFLAGS += -DHAVE_INTEL_ATOMIC_PRIMITIVES
    endif
 
@@ -597,7 +599,10 @@
   ifeq ($(call isTargetOs, macosx), true)
     JAWT_LIBS := -lawt_lwawt
   else
-    JAWT_LIBS := -lawt
+    JAWT_LIBS :=
+    ifeq ($(call isTargetOs, solaris), false)
+      JAWT_LIBS += -lawt
+    endif
     ifeq ($(ENABLE_HEADLESS_ONLY), false)
       JAWT_LIBS += -lawt_xawt
     else
@@ -624,6 +629,7 @@
       LDFLAGS_unix := -L$(INSTALL_LIBRARIES_HERE), \
       LDFLAGS_macosx := -Wl$(COMMA)-rpath$(COMMA)@loader_path, \
       LIBS_unix := $(JAWT_LIBS) $(JDKLIB_LIBS), \
+      LIBS_solaris := $(X_LIBS) -lXrender, \
       LIBS_macosx := -framework Cocoa, \
   ))
 
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/make/modules/java.desktop/Lib.gmk jdk18u-jdk-18.0.2.1-ga/make/modules/java.desktop/Lib.gmk
--- jdk18u-jdk-18.0.2.1-ga.orig/make/modules/java.desktop/Lib.gmk	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/make/modules/java.desktop/Lib.gmk	2024-08-17 18:29:44.457463511 +0200
@@ -47,10 +47,15 @@
       -DX_PLATFORM=X_$(OPENJDK_TARGET_OS_UPPERCASE) \
       -DUSE_PORTS=TRUE \
       -DUSE_DAUDIO=TRUE \
-      -DUSE_PLATFORM_MIDI_OUT=TRUE \
-      -DUSE_PLATFORM_MIDI_IN=TRUE \
       #
 
+  ifeq ($(call isTargetOs, solaris), false)
+    LIBJSOUND_CFLAGS += \
+        -DUSE_PLATFORM_MIDI_OUT=TRUE \
+        -DUSE_PLATFORM_MIDI_IN=TRUE \
+        #
+  endif
+
   ifeq ($(call isTargetOs, macosx), true)
     LIBJSOUND_TOOLCHAIN := TOOLCHAIN_LINK_CXX
   endif
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/make/modules/java.instrument/Lib.gmk jdk18u-jdk-18.0.2.1-ga/make/modules/java.instrument/Lib.gmk
--- jdk18u-jdk-18.0.2.1-ga.orig/make/modules/java.instrument/Lib.gmk	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/make/modules/java.instrument/Lib.gmk	2024-08-17 18:29:44.458853056 +0200
@@ -45,11 +45,13 @@
         $(call SET_SHARED_LIBRARY_ORIGIN) \
         $(LIBINSTRUMENT_LDFLAGS), \
     LDFLAGS_linux := -L$(call FindLibDirForModule, java.base), \
+    LDFLAGS_solaris := -L$(call FindLibDirForModule, java.base), \
     LDFLAGS_macosx := -L$(call FindLibDirForModule, java.base), \
     LDFLAGS_aix := -L$(SUPPORT_OUTPUTDIR)/native/java.base, \
     LIBS := $(JDKLIB_LIBS), \
     LIBS_unix := -ljava -ljvm $(LIBZ_LIBS), \
     LIBS_linux := -ljli $(LIBDL), \
+    LIBS_solaris := -ljli $(LIBDL), \
     LIBS_aix := -liconv -ljli_static $(LIBDL), \
     LIBS_macosx := -ljli -liconv -framework Cocoa -framework Security \
         -framework ApplicationServices, \
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/make/modules/java.management/Lib.gmk jdk18u-jdk-18.0.2.1-ga/make/modules/java.management/Lib.gmk
--- jdk18u-jdk-18.0.2.1-ga.orig/make/modules/java.management/Lib.gmk	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/make/modules/java.management/Lib.gmk	2024-08-17 18:29:44.459362889 +0200
@@ -28,7 +28,7 @@
 ################################################################################
 
 LIBMANAGEMENT_OPTIMIZATION := HIGH
-ifeq ($(call isTargetOs, linux), true)
+ifeq ($(call isTargetOs, solaris linux), true)
   ifeq ($(COMPILE_WITH_DEBUG_SYMBOLS), true)
     LIBMANAGEMENT_OPTIMIZATION := LOW
   endif
@@ -41,6 +41,7 @@
     LDFLAGS := $(LDFLAGS_JDKLIB) \
         $(call SET_SHARED_LIBRARY_ORIGIN), \
     LIBS := $(JDKLIB_LIBS), \
+    LIBS_solaris := -lkstat, \
     LIBS_aix := -lperfstat,\
     LIBS_windows := jvm.lib psapi.lib $(WIN_JAVA_LIB) advapi32.lib, \
 ))
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/make/modules/java.prefs/Lib.gmk jdk18u-jdk-18.0.2.1-ga/make/modules/java.prefs/Lib.gmk
--- jdk18u-jdk-18.0.2.1-ga.orig/make/modules/java.prefs/Lib.gmk	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/make/modules/java.prefs/Lib.gmk	2024-08-17 18:29:44.459806116 +0200
@@ -41,6 +41,7 @@
         $(call SET_SHARED_LIBRARY_ORIGIN), \
     LIBS_unix := -ljvm, \
     LIBS_linux := -ljava, \
+    LIBS_solaris := -ljava, \
     LIBS_aix := -ljava, \
     LIBS_macosx := -framework CoreFoundation -framework Foundation, \
     LIBS_windows := advapi32.lib jvm.lib $(WIN_JAVA_LIB), \
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/make/modules/jdk.attach/Lib.gmk jdk18u-jdk-18.0.2.1-ga/make/modules/jdk.attach/Lib.gmk
--- jdk18u-jdk-18.0.2.1-ga.orig/make/modules/jdk.attach/Lib.gmk	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/make/modules/jdk.attach/Lib.gmk	2024-08-17 18:29:44.460267171 +0200
@@ -42,6 +42,7 @@
     LDFLAGS := $(LDFLAGS_JDKLIB) \
         $(call SET_SHARED_LIBRARY_ORIGIN), \
     LIBS := $(JDKLIB_LIBS), \
+    LIBS_solaris := -ldoor, \
     LIBS_windows := $(WIN_JAVA_LIB) advapi32.lib psapi.lib, \
 ))
 
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/make/modules/jdk.crypto.cryptoki/Copy.gmk jdk18u-jdk-18.0.2.1-ga/make/modules/jdk.crypto.cryptoki/Copy.gmk
--- jdk18u-jdk-18.0.2.1-ga.orig/make/modules/jdk.crypto.cryptoki/Copy.gmk	1970-01-01 01:00:00.000000000 +0100
+++ jdk18u-jdk-18.0.2.1-ga/make/modules/jdk.crypto.cryptoki/Copy.gmk	2024-08-17 18:29:44.537587457 +0200
@@ -0,0 +1,45 @@
+#
+# Copyright (c) 2014, 2019, Oracle and/or its affiliates. All rights reserved.
+# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+#
+# This code is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 2 only, as
+# published by the Free Software Foundation.  Oracle designates this
+# particular file as subject to the "Classpath" exception as provided
+# by Oracle in the LICENSE file that accompanied this code.
+#
+# This code is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+# version 2 for more details (a copy is included in the LICENSE file that
+# accompanied this code).
+#
+# You should have received a copy of the GNU General Public License version
+# 2 along with this work; if not, write to the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+# or visit www.oracle.com if you need additional information or have any
+# questions.
+#
+
+include CopyCommon.gmk
+
+################################################################################
+
+ifeq ($(call isTargetOs, solaris), true)
+
+  SUNPKCS11_CFG_SRC := \
+      $(TOPDIR)/src/jdk.crypto.cryptoki/solaris/conf/security/sunpkcs11-solaris.cfg
+  SUNPKCS11_CFG_DST := $(CONF_DST_DIR)/security/sunpkcs11-solaris.cfg
+
+  $(SUNPKCS11_CFG_DST): $(SUNPKCS11_CFG_SRC)
+	$(call install-file)
+
+  SECURITY_PKCS11_CONF_FILES += $(SUNPKCS11_CFG_DST)
+
+  TARGETS := $(SUNPKCS11_CFG_DST)
+
+endif
+
+################################################################################
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/make/modules/jdk.hotspot.agent/Lib.gmk jdk18u-jdk-18.0.2.1-ga/make/modules/jdk.hotspot.agent/Lib.gmk
--- jdk18u-jdk-18.0.2.1-ga.orig/make/modules/jdk.hotspot.agent/Lib.gmk	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/make/modules/jdk.hotspot.agent/Lib.gmk	2024-08-17 18:29:44.460720025 +0200
@@ -65,10 +65,11 @@
     CFLAGS := $(CFLAGS_JDKLIB) $(SA_CFLAGS), \
     CXXFLAGS := $(CXXFLAGS_JDKLIB) $(SA_CFLAGS) $(SA_CXXFLAGS), \
     EXTRA_SRC := $(LIBSA_EXTRA_SRC), \
-    LDFLAGS := $(LDFLAGS_JDKLIB) $(call SET_SHARED_LIBRARY_ORIGIN), \
+    LDFLAGS := $(LDFLAGS_JDKLIB) $(SA_LDFLAGS) $(call SET_SHARED_LIBRARY_ORIGIN), \
     LIBS := $(LIBCXX), \
     LIBS_unix := -ljava, \
     LIBS_linux := $(LIBDL), \
+    LIBS_solaris := -ldl -lstdc++ -lthread -lproc, \
     LIBS_macosx := -framework Foundation \
         -framework JavaRuntimeSupport -framework Security -framework CoreFoundation, \
     LIBS_windows := dbgeng.lib $(WIN_JAVA_LIB), \
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/make/modules/jdk.jdwp.agent/Lib.gmk jdk18u-jdk-18.0.2.1-ga/make/modules/jdk.jdwp.agent/Lib.gmk
--- jdk18u-jdk-18.0.2.1-ga.orig/make/modules/jdk.jdwp.agent/Lib.gmk	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/make/modules/jdk.jdwp.agent/Lib.gmk	2024-08-17 18:29:44.461209939 +0200
@@ -37,6 +37,7 @@
     LDFLAGS := $(LDFLAGS_JDKLIB) \
         $(call SET_SHARED_LIBRARY_ORIGIN), \
     LIBS_linux := -lpthread, \
+    LIBS_solaris := -lnsl -lsocket, \
     LIBS_windows := $(JDKLIB_LIBS) ws2_32.lib iphlpapi.lib, \
 ))
 
@@ -62,6 +63,7 @@
         $(call SET_SHARED_LIBRARY_ORIGIN), \
     LIBS := $(JDKLIB_LIBS), \
     LIBS_linux := $(LIBDL), \
+    LIBS_solaris := $(LIBDL), \
     LIBS_macosx := -liconv, \
     LIBS_aix := -liconv, \
 ))
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/make/modules/jdk.management/Lib.gmk jdk18u-jdk-18.0.2.1-ga/make/modules/jdk.management/Lib.gmk
--- jdk18u-jdk-18.0.2.1-ga.orig/make/modules/jdk.management/Lib.gmk	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/make/modules/jdk.management/Lib.gmk	2024-08-17 18:29:44.461700327 +0200
@@ -35,7 +35,7 @@
 endif
 
 LIBMANAGEMENT_EXT_OPTIMIZATION := HIGH
-ifeq ($(call isTargetOs, linux), true)
+ifeq ($(call isTargetOs, solaris linux), true)
   ifeq ($(COMPILE_WITH_DEBUG_SYMBOLS), true)
     LIBMANAGEMENT_EXT_OPTIMIZATION := LOW
   endif
@@ -49,6 +49,7 @@
     LDFLAGS := $(LDFLAGS_JDKLIB) \
         $(call SET_SHARED_LIBRARY_ORIGIN), \
     LIBS := $(JDKLIB_LIBS), \
+    LIBS_solaris := -lkstat, \
     LIBS_aix := -lperfstat,\
     LIBS_windows := jvm.lib psapi.lib $(WIN_JAVA_LIB) advapi32.lib, \
 ))
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/make/modules/jdk.net/Lib.gmk jdk18u-jdk-18.0.2.1-ga/make/modules/jdk.net/Lib.gmk
--- jdk18u-jdk-18.0.2.1-ga.orig/make/modules/jdk.net/Lib.gmk	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/make/modules/jdk.net/Lib.gmk	2024-08-17 18:29:44.462139561 +0200
@@ -36,6 +36,7 @@
       LDFLAGS := $(LDFLAGS_JDKLIB) \
           $(call SET_SHARED_LIBRARY_ORIGIN), \
       LIBS := -ljava, \
+      LIBS_solaris := -lsocket, \
       LIBS_linux := -ljvm, \
   ))
 
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/make/modules/jdk.sctp/Lib.gmk jdk18u-jdk-18.0.2.1-ga/make/modules/jdk.sctp/Lib.gmk
--- jdk18u-jdk-18.0.2.1-ga.orig/make/modules/jdk.sctp/Lib.gmk	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/make/modules/jdk.sctp/Lib.gmk	2024-08-17 18:29:44.462592152 +0200
@@ -44,6 +44,7 @@
             $(call SET_SHARED_LIBRARY_ORIGIN), \
         LIBS_unix := -lnio -lnet -ljava -ljvm, \
         LIBS_linux := -lpthread $(LIBDL), \
+        LIBS_solaris := -lsocket, \
     ))
 
     TARGETS += $(BUILD_LIBSCTP)
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/make/RunTestsPrebuilt.gmk jdk18u-jdk-18.0.2.1-ga/make/RunTestsPrebuilt.gmk
--- jdk18u-jdk-18.0.2.1-ga.orig/make/RunTestsPrebuilt.gmk	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/make/RunTestsPrebuilt.gmk	2024-08-17 18:29:44.441397546 +0200
@@ -163,6 +163,8 @@
     OPENJDK_TARGET_OS := linux
   else ifeq ($(UNAME_OS), Darwin)
     OPENJDK_TARGET_OS := macosx
+  else ifeq ($(UNAME_OS), SunOS)
+    OPENJDK_TARGET_OS := solaris
   else
     OPENJDK_TARGET_OS := $(UNAME_OS)
   endif
@@ -172,15 +174,28 @@
 # Assume little endian unless otherwise specified
 OPENJDK_TARGET_CPU_ENDIAN := little
 
-UNAME_CPU := $(shell $(UNAME) -m)
-ifeq ($(UNAME_CPU), i686)
-  OPENJDK_TARGET_CPU := x86
-  OPENJDK_TARGET_CPU_BITS := 32
-else
-  # Assume all others are 64-bit. We use the same CPU name as uname for
-  # at least x86_64 and aarch64.
-  OPENJDK_TARGET_CPU := $(UNAME_CPU)
+ifeq ($(OPENJDK_TARGET_OS), solaris)
+  # On solaris, use uname -p
+  UNAME_CPU := $(shell $(UNAME) -p)
+  # Assume 64-bit platform
   OPENJDK_TARGET_CPU_BITS := 64
+  ifeq ($(UNAME_CPU), i386)
+    OPENJDK_TARGET_CPU := x86_64
+  else
+    OPENJDK_TARGET_CPU := $(UNAME_CPU)
+  endif
+else
+  # ... all others use uname -m
+  UNAME_CPU := $(shell $(UNAME) -m)
+  ifeq ($(UNAME_CPU), i686)
+    OPENJDK_TARGET_CPU := x86
+    OPENJDK_TARGET_CPU_BITS := 32
+  else
+    # Assume all others are 64-bit. We use the same CPU name as uname for
+    # at least x86_64 and aarch64.
+    OPENJDK_TARGET_CPU := $(UNAME_CPU)
+    OPENJDK_TARGET_CPU_BITS := 64
+  endif
 endif
 
 OPENJDK_TARGET_CPU_ARCH := $(OPENJDK_TARGET_CPU)
@@ -205,6 +220,11 @@
 else ifeq ($(OPENJDK_TARGET_OS), macosx)
   NUM_CORES := $(shell /usr/sbin/sysctl -n hw.ncpu)
   MEMORY_SIZE := $(shell $(EXPR) `/usr/sbin/sysctl -n hw.memsize` / 1024 / 1024)
+else ifeq ($(OPENJDK_TARGET_OS), solaris)
+  NUM_CORES := $(shell /usr/sbin/psrinfo -v | $(GREP) -c on-line)
+  MEMORY_SIZE := $(shell \
+      /usr/sbin/prtconf 2> /dev/null | $(GREP) "^Memory [Ss]ize" | $(AWK) '{print $$3}' \
+  )
 else ifeq ($(OPENJDK_TARGET_OS), windows)
   NUM_CORES := $(NUMBER_OF_PROCESSORS)
   MEMORY_SIZE := $(shell \
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/make/RunTestsPrebuiltSpec.gmk jdk18u-jdk-18.0.2.1-ga/make/RunTestsPrebuiltSpec.gmk
--- jdk18u-jdk-18.0.2.1-ga.orig/make/RunTestsPrebuiltSpec.gmk	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/make/RunTestsPrebuiltSpec.gmk	2024-08-17 18:29:44.441840542 +0200
@@ -172,6 +172,16 @@
 HG := hg
 ULIMIT := ulimit
 
+# On Solaris gnu versions of some tools are required.
+ifeq ($(OPENJDK_BUILD_OS), solaris)
+  AWK := gawk
+  GREP := ggrep
+  EGREP := ggrep -E
+  FGREP := grep -F
+  SED := gsed
+  TAR := gtar
+endif
+
 ifeq ($(OPENJDK_BUILD_OS), windows)
   PATHTOOL := cygpath
 endif
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/make/scripts/compare_exceptions.sh.incl jdk18u-jdk-18.0.2.1-ga/make/scripts/compare_exceptions.sh.incl
--- jdk18u-jdk-18.0.2.1-ga.orig/make/scripts/compare_exceptions.sh.incl	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/make/scripts/compare_exceptions.sh.incl	2024-08-17 18:29:44.463981019 +0200
@@ -45,6 +45,21 @@
         ./hotspot/gtest/server/libjvm.so
         "
    fi
+elif [ "$OPENJDK_TARGET_OS" = "solaris" ]; then
+  SKIP_BIN_DIFF="true"
+  SKIP_FULLDUMP_DIFF="true"
+  MAX_KNOWN_DIS_DIFF_SIZE="3000"
+  SORT_SYMBOLS="
+      ./lib/libfontmanager.so
+      ./lib/libjimage.so
+      ./lib/server/libjvm.so
+      ./hotspot/gtest/server/libjvm.so
+      "
+  KNOWN_DIS_DIFF="
+      ./lib/libfontmanager.so
+      ./lib/libsaproc.so
+  "
+  STRIP_TESTS_BEFORE_COMPARE="true"
 elif [ "$OPENJDK_TARGET_OS" = "windows" ]; then
   SKIP_BIN_DIFF="true"
   SKIP_FULLDUMP_DIFF="true"
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/make/scripts/compare.sh jdk18u-jdk-18.0.2.1-ga/make/scripts/compare.sh
--- jdk18u-jdk-18.0.2.1-ga.orig/make/scripts/compare.sh	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/make/scripts/compare.sh	2024-08-17 18:29:44.463553962 +0200
@@ -72,7 +72,14 @@
 # Disassembly diff filters. These filters try to filter out ephemeral parts of the
 # disassembly, such as hard-coded addresses, to be able to catch "actual" differences.
 
-if [ "$OPENJDK_TARGET_OS" = "windows" ]; then
+if [ "$OPENJDK_TARGET_OS" = "solaris" ]; then
+  if [ "$OPENJDK_TARGET_CPU" = "x86_64" ]; then
+    # Random strings looking like this differ: <.XAKoKoPIac2W0OA.
+    DIS_DIFF_FILTER="$SED \
+        -e 's/<\.[A-Za-z0-9]\{\15}\./<.SYM./' \
+        "
+  fi
+elif [ "$OPENJDK_TARGET_OS" = "windows" ]; then
   if [ "$OPENJDK_TARGET_CPU" = "x86" ]; then
     DIS_DIFF_FILTER="$SED -r \
         -e 's/^  [0-9A-F]{16}: //' \
@@ -439,7 +446,14 @@
     fi
 
     CONTENTS_DIFF_FILE=$WORK_DIR/$ZIP_FILE.diff
-    $DIFF -rq $OTHER_UNZIPDIR $THIS_UNZIPDIR > $CONTENTS_DIFF_FILE
+    # On solaris, there is no -q option.
+    if [ "$OPENJDK_TARGET_OS" = "solaris" ]; then
+        $DIFF -r $OTHER_UNZIPDIR $THIS_UNZIPDIR \
+            | $GREP -v -e "^<" -e "^>" -e "^Common subdirectories:" \
+            > $CONTENTS_DIFF_FILE
+    else
+        $DIFF -rq $OTHER_UNZIPDIR $THIS_UNZIPDIR > $CONTENTS_DIFF_FILE
+    fi
 
     ONLY_OTHER=$($GREP "^Only in $OTHER_UNZIPDIR" $CONTENTS_DIFF_FILE)
     ONLY_THIS=$($GREP "^Only in $THIS_UNZIPDIR" $CONTENTS_DIFF_FILE)
@@ -459,8 +473,14 @@
     fi
 
     if [ "$CMP_ZIPS_CONTENTS" = "true" ]; then
-        DIFFING_FILES=$($GREP -e "differ$" $CONTENTS_DIFF_FILE \
-            | $CUT -f 2 -d ' ' | $SED "s|$OTHER_UNZIPDIR/||g")
+        if [ "$OPENJDK_TARGET_OS" = "solaris" ]; then
+            DIFFING_FILES=$($GREP -e 'differ$' -e '^diff ' $CONTENTS_DIFF_FILE \
+                | $SED -e 's/^Files //g' -e 's/diff -r //g' | $CUT -f 1 -d ' ' \
+                | $SED "s|$OTHER_UNZIPDIR/||g")
+        else
+            DIFFING_FILES=$($GREP -e "differ$" $CONTENTS_DIFF_FILE \
+                | $CUT -f 2 -d ' ' | $SED "s|$OTHER_UNZIPDIR/||g")
+        fi
 
         # Separate executable/library files from other files in zip.
         DIFFING_TEXT_FILES=
@@ -797,6 +817,10 @@
         # to filter out that extra information.
         $DUMPBIN -exports $OTHER_FILE | $GREP  -E '^ +[0-9A-F]+ +[0-9A-F]+ [0-9A-F]+' | sed 's/ = .*//g' | cut -c27- | $SYM_SORT_CMD > $WORK_FILE_BASE.symbols.other
         $DUMPBIN -exports $THIS_FILE  | $GREP  -E '^ +[0-9A-F]+ +[0-9A-F]+ [0-9A-F]+' | sed 's/ = .*//g' | cut -c27- | $SYM_SORT_CMD > $WORK_FILE_BASE.symbols.this
+    elif [ "$OPENJDK_TARGET_OS" = "solaris" ]; then
+        # Some symbols get seemingly random 15 character prefixes. Filter them out.
+        $NM -a $ORIG_OTHER_FILE 2> /dev/null | $GREP -v $NAME | $AWK '{print $2, $3, $4, $5}' | $SED 's/^\([a-zA-Z] [\.\$]\)[a-zA-Z0-9_\$]\{15,15\}\./\1./g' | $SYM_SORT_CMD > $WORK_FILE_BASE.symbols.other
+        $NM -a $ORIG_THIS_FILE  2> /dev/null | $GREP -v $NAME | $AWK '{print $2, $3, $4, $5}' | $SED 's/^\([a-zA-Z] [\.\$]\)[a-zA-Z0-9_\$]\{15,15\}\./\1./g' | $SYM_SORT_CMD > $WORK_FILE_BASE.symbols.this
     elif [ "$OPENJDK_TARGET_OS" = "aix" ]; then
         $OBJDUMP -T $ORIG_OTHER_FILE 2> /dev/null | $GREP -v $NAME | $AWK '{print $2, $3, $4, $5}' | $SYM_SORT_CMD > $WORK_FILE_BASE.symbols.other
         $OBJDUMP -T $ORIG_THIS_FILE  2> /dev/null | $GREP -v $NAME | $AWK '{print $2, $3, $4, $5}' | $SYM_SORT_CMD > $WORK_FILE_BASE.symbols.this
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/make/scripts/hide_important_warnings_from_javac.sh jdk18u-jdk-18.0.2.1-ga/make/scripts/hide_important_warnings_from_javac.sh
--- jdk18u-jdk-18.0.2.1-ga.orig/make/scripts/hide_important_warnings_from_javac.sh	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/make/scripts/hide_important_warnings_from_javac.sh	2024-08-17 18:29:44.464390963 +0200
@@ -22,8 +22,13 @@
 # questions.
 #
 
-GREP=grep
-
+if [ -x /usr/bin/ggrep ] ; then
+    # Gnu grep on Solaris
+    # (reference configure and build/solaris-i586-clientANDserver-release/spec.gmk
+    GREP=/usr/bin/ggrep
+else
+    GREP=grep
+fi
 #
 EXP="Note: Some input files use or override a deprecated API."
 EXP="${EXP}|Note: Recompile with -Xlint:deprecation for details."
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/make/scripts/update_copyright_year.sh jdk18u-jdk-18.0.2.1-ga/make/scripts/update_copyright_year.sh
--- jdk18u-jdk-18.0.2.1-ga.orig/make/scripts/update_copyright_year.sh	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/make/scripts/update_copyright_year.sh	2024-08-17 18:29:44.464804360 +0200
@@ -26,7 +26,11 @@
 # Script to update the Copyright YEAR range in Mercurial sources.
 #  (Originally from xdono, Thanks!)
 
-awk=awk
+if [ "`uname -s`" = "SunOS" ] ; then
+  awk=nawk
+else
+  awk=awk
+fi
 
 # Stop on any error
 set -e
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/make/test/JtregNativeHotspot.gmk jdk18u-jdk-18.0.2.1-ga/make/test/JtregNativeHotspot.gmk
--- jdk18u-jdk-18.0.2.1-ga.orig/make/test/JtregNativeHotspot.gmk	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/make/test/JtregNativeHotspot.gmk	2024-08-17 18:29:44.465726341 +0200
@@ -869,6 +869,10 @@
 
 BUILD_HOTSPOT_JTREG_EXECUTABLES_LIBS_exesigtest := -ljvm
 
+ifeq ($(call isTargetOs, solaris), true)
+    BUILD_HOTSPOT_JTREG_EXCLUDE += libterminatedThread.c
+endif
+
 ifeq ($(call isTargetOs, windows), true)
     BUILD_HOTSPOT_JTREG_EXECUTABLES_CFLAGS_exeFPRegs := -MT
     BUILD_HOTSPOT_JTREG_EXCLUDE += exesigtest.c libterminatedThread.c libTestJNI.c
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/make/test/JtregNativeJdk.gmk jdk18u-jdk-18.0.2.1-ga/make/test/JtregNativeJdk.gmk
--- jdk18u-jdk-18.0.2.1-ga.orig/make/test/JtregNativeJdk.gmk	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/make/test/JtregNativeJdk.gmk	2024-08-17 18:29:44.466186052 +0200
@@ -77,6 +77,9 @@
   ifeq ($(call isTargetOs, linux), true)
     BUILD_JDK_JTREG_LIBRARIES_LIBS_libInheritedChannel := -ljava
     BUILD_JDK_JTREG_EXECUTABLES_LIBS_exelauncher := -ldl
+  else ifeq ($(call isTargetOs, solaris), true)
+    BUILD_JDK_JTREG_LIBRARIES_LIBS_libInheritedChannel := -ljava -lsocket -lnsl
+    BUILD_JDK_JTREG_EXECUTABLES_LIBS_exelauncher := -lthread -ldl
   endif
   BUILD_JDK_JTREG_EXECUTABLES_LIBS_exeJliLaunchTest := -ljli
   BUILD_JDK_JTREG_EXECUTABLES_LIBS_exeCallerAccessTest := -ljvm
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/src/hotspot/cpu/x86/globalDefinitions_x86.hpp jdk18u-jdk-18.0.2.1-ga/src/hotspot/cpu/x86/globalDefinitions_x86.hpp
--- jdk18u-jdk-18.0.2.1-ga.orig/src/hotspot/cpu/x86/globalDefinitions_x86.hpp	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/src/hotspot/cpu/x86/globalDefinitions_x86.hpp	2024-08-17 18:29:44.466785287 +0200
@@ -65,7 +65,7 @@
 #define INCLUDE_RTM_OPT 1
 #endif
 
-#if defined(LINUX) || defined(__APPLE__)
+#if defined(LINUX) || defined(SOLARIS) || defined(__APPLE__)
 #define SUPPORT_RESERVED_STACK_AREA
 #endif
 
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/src/hotspot/os/posix/include/jvm_md.h jdk18u-jdk-18.0.2.1-ga/src/hotspot/os/posix/include/jvm_md.h
--- jdk18u-jdk-18.0.2.1-ga.orig/src/hotspot/os/posix/include/jvm_md.h	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/src/hotspot/os/posix/include/jvm_md.h	2024-08-17 18:29:44.467364880 +0200
@@ -54,7 +54,7 @@
 #endif
 #define JNI_LIB_NAME(NAME) JNI_LIB_PREFIX NAME JNI_LIB_SUFFIX
 
-#if defined(AIX)
+#if defined(AIX) || defined(SOLARIS)
 #define JVM_MAXPATHLEN MAXPATHLEN
 #else
 // Hack: MAXPATHLEN is 4095 on some Linux and 4096 on others. This may
@@ -87,8 +87,14 @@
 #define JVM_SIGTERM    SIGTERM
 
 #define BREAK_SIGNAL     SIGQUIT           /* Thread dumping support.    */
+#ifdef SOLARIS
+#define ASYNC_SIGNAL     SIGJVM2           /* Event-based suspend/resume support */
+#endif // SOLARIS
 #define SHUTDOWN1_SIGNAL SIGHUP            /* Shutdown Hooks support.    */
 #define SHUTDOWN2_SIGNAL SIGINT
 #define SHUTDOWN3_SIGNAL SIGTERM
 
+/* With 1.4.1 libjsig added versioning: used in os_solaris.cpp and jsig.c */
+#define JSIG_VERSION_1_4_1   0x30140100
+
 #endif /* !_JAVASOFT_JVM_MD_H_ */
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/src/hotspot/os/posix/os_posix.cpp jdk18u-jdk-18.0.2.1-ga/src/hotspot/os/posix/os_posix.cpp
--- jdk18u-jdk-18.0.2.1-ga.orig/src/hotspot/os/posix/os_posix.cpp	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/src/hotspot/os/posix/os_posix.cpp	2024-08-17 18:29:44.468389496 +0200
@@ -476,7 +476,7 @@
   st->print("%d", sysconf(_SC_CHILD_MAX));
 
   print_rlimit(st, ", THREADS", RLIMIT_THREADS);
-#else
+#elif !defined(SOLARIS)
   print_rlimit(st, ", NPROC", RLIMIT_NPROC);
 #endif
 
@@ -494,6 +494,12 @@
   print_rlimit(st, ", MEMLOCK", RLIMIT_MEMLOCK, true);
 #endif
 
+#if defined(SOLARIS)
+  // maximum size of mapped address space of a process in bytes;
+  // if the limit is exceeded, mmap and brk fail
+  print_rlimit(st, ", VMEM", RLIMIT_VMEM, true);
+#endif
+
   // MacOS; The maximum size (in bytes) to which a process's resident set size may grow.
 #if defined(__APPLE__)
   print_rlimit(st, ", RSS", RLIMIT_RSS, true);
@@ -920,7 +926,7 @@
 // page size which again depends on the concrete system the VM is running
 // on. Space for libc guard pages is not included in this size.
 jint os::Posix::set_minimum_stack_sizes() {
-  size_t os_min_stack_allowed = PTHREAD_STACK_MIN;
+  size_t os_min_stack_allowed = SOLARIS_ONLY(thr_min_stack()) NOT_SOLARIS(PTHREAD_STACK_MIN);
 
   _java_thread_min_stack_allowed = _java_thread_min_stack_allowed +
                                    StackOverflow::stack_guard_zone_size() +
@@ -1240,7 +1246,8 @@
   if ((status = pthread_mutexattr_settype(_mutexAttr, PTHREAD_MUTEX_NORMAL)) != 0) {
     fatal("pthread_mutexattr_settype: %s", os::strerror(status));
   }
-  os::PlatformMutex::init();
+  // Solaris has it's own PlatformMutex, distinct from the one for POSIX.
+  NOT_SOLARIS(os::PlatformMutex::init();)
 }
 
 static int (*_pthread_condattr_setclock)(pthread_condattr_t *, clockid_t) = NULL;
@@ -1511,6 +1518,7 @@
 // Shared pthread_mutex/cond based PlatformEvent implementation.
 // Not currently usable by Solaris.
 
+#ifndef SOLARIS
 
 // PlatformEvent
 //
@@ -1941,6 +1949,8 @@
   }
 }
 
+#endif // !SOLARIS
+
 // Darwin has no "environ" in a dynamic library.
 #ifdef __APPLE__
   #define environ (*_NSGetEnviron())
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/src/hotspot/os/posix/os_posix.hpp jdk18u-jdk-18.0.2.1-ga/src/hotspot/os/posix/os_posix.hpp
--- jdk18u-jdk-18.0.2.1-ga.orig/src/hotspot/os/posix/os_posix.hpp	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/src/hotspot/os/posix/os_posix.hpp	2024-08-17 18:29:44.468876460 +0200
@@ -132,6 +132,8 @@
   sigjmp_buf _jmpbuf;
 };
 
+#ifndef SOLARIS
+
 /*
  * This is the platform-specific implementation underpinning
  * the ParkEvent class, which itself underpins Java-level monitor
@@ -297,4 +299,6 @@
   void notify_all();
 };
 
+#endif // !SOLARIS
+
 #endif // OS_POSIX_OS_POSIX_HPP
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/src/hotspot/os/posix/os_posix.inline.hpp jdk18u-jdk-18.0.2.1-ga/src/hotspot/os/posix/os_posix.inline.hpp
--- jdk18u-jdk-18.0.2.1-ga.orig/src/hotspot/os/posix/os_posix.inline.hpp	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/src/hotspot/os/posix/os_posix.inline.hpp	2024-08-17 18:29:44.469333418 +0200
@@ -45,6 +45,7 @@
   return _result; \
 } while(false)
 
+#ifndef SOLARIS
 // Aix does not have NUMA support but need these for compilation.
 inline bool os::numa_has_static_binding()   { AIX_ONLY(ShouldNotReachHere();) return true; }
 inline bool os::numa_has_group_homing()     { AIX_ONLY(ShouldNotReachHere();) return false;  }
@@ -77,4 +78,6 @@
   assert_status(status == 0, status, "cond_broadcast");
 }
 
+#endif // !SOLARIS
+
 #endif // OS_POSIX_OS_POSIX_INLINE_HPP
diff -Nru jdk18u-jdk-18.0.2.1-ga.orig/src/hotspot/os/posix/vmError_posix.cpp jdk18u-jdk-18.0.2.1-ga/src/hotspot/os/posix/vmError_posix.cpp
--- jdk18u-jdk-18.0.2.1-ga.orig/src/hotspot/os/posix/vmError_posix.cpp	2022-08-16 01:13:26.000000000 +0200
+++ jdk18u-jdk-18.0.2.1-ga/src/hotspot/os/posix/vmError_posix.cpp	2024-08-17 18:29:44.469735038 +0200
@@ -39,6 +39,9 @@
 #include <sys/syscall.h>
 #include <unistd.h>
 #endif
+#ifdef SOLARIS
+#include <thread.h>
+#endif
 #ifdef AIX
 #include <unistd.h>
 #endif
